SystemOrganization addCategory: #'TOC-Declaration-Core'!
SystemOrganization addCategory: #'TOC-Declaration-Visitor'!
SystemOrganization addCategory: #'TOC-Tracking-Core'!

!RBParser class methodsFor: '*toc-declaration' stamp: 'OzC 12/16/2011 20:57'!
permissiveParseMethod: source
	[^ RBParser parseMethod: source] on: Error do: [:e | Transcript cr; show: e].
	^ RBParser parseMethod: 'notValidMethodFailToParse'! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
fullClassName2

	^ self classIsMeta
		ifFalse: [self className]
		ifTrue: [self className, ' class']! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/18/2012 12:34'!
loadDeclarationIn: toc mcVersion: mc
	|def clsDef|
	(toc matchSelector: self selector) ifFalse: [^self].
	def := ((self as: TOMCMethodDefinition) mcVersion: mc).
	(TOFilterVisitor canBeFilter: def ) ifTrue: [^ self]. 
	toc addSelector: def. 
	
	! !

!MCMethodDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/17/2011 11:32'!
tocName 
	^ self fullClassName2 ,'>>',selector ! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 12/21/2011 13:24'!
isInTop1000 
	^ FSource cachedPkgCtg includesKey: self package projectName ! !

!MCVersion methodsFor: '*toc-declaration' stamp: 'OzC 12/20/2011 14:39'!
loadDeclarationIn: "(TOProject)"toc 
	snapshot definitions do: [:def |
		def loadDeclarationIn: toc mcVersion: self.] 
	! !

!MCPackage methodsFor: '*toc-monticello' stamp: 'OzC 12/21/2011 13:25'!
projectName 
	^ self name copyUpTo: $-! !

Dictionary subclass: #TOProjectDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 1/10/2012 22:36'!
allAbstracts
	^ self allCategory: #isAbstractSelector! !

!TOProjectDictionary methodsFor: 'flat-selectors-core' stamp: 'OzC 1/10/2012 22:57'!
allCategories
	^ (self class allSelectorsInCategory: 'flat-selectors-category') collect: [:sel |
		sel -> (self perform: sel) size]! !

!TOProjectDictionary methodsFor: 'flat-selectors-core' stamp: 'OzC 12/21/2011 13:41'!
allCategory: ctg
	^ self  inject: SortedCollection new into: [:sor :pot|
		sor addAll: (pot selectors select: ctg) ; yourself].! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:40'!
allDuplicates
	^ self inject: Dictionary new into: [:dic :pot | 
		(pot selectors) do: [:tos | |v n|
			n := tos duplicatesLength.
			n > 0 ifTrue: [
				v:= dic at: n ifAbsentPut: [OrderedCollection new].
				v add: tos]].
		dic].! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:41'!
allExtras
	^ self allCategory: #isExtra! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:44'!
allProjectsWithCategory: ctg
	^ self select: [:top | (top selectors select: ctg) size > 0]! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 22:54'!
allProjectsWithMixPredicates
	^ (self select: #hasMixPredicates) collect: #copyMixPredicates! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 17:03'!
allProjectsWithTypePredicates
	^ self select: [:top | (top selectors select: #isTypePredicate) size > 0]! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:42'!
allStatePredicates
	^ self allCategory: #isStatePredicate! !

!TOProjectDictionary methodsFor: 'flat-selectors-category' stamp: 'OzC 12/21/2011 13:41'!
allTypePredicates
	^ self allCategory: #isTypePredicate! !

!TOProjectDictionary methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 14:13'!
allWithSource: source
	^ self  inject: SortedCollection new into: [:sor :pot|
		sor addAll: (pot selectors select: [:tos|
			source match: tos mthDef source]) ; yourself].! !

!MCDefinition methodsFor: '*toc-declaration' stamp: 'OzC 12/20/2011 14:39'!
loadDeclarationIn: toc mcVersion: mcVersion
	! !

FMthDef subclass: #TOMCMethodDefinition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

RBProgramNodeVisitor subclass: #TODeclarationVisitor
	instanceVariableNames: 'accepted mthDef'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

TODeclarationVisitor subclass: #TODAbstractSelectorVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODAbstractSelectorVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:58'!
acceptMessageNode: aMessageNode 
	((aMessageNode receiver isVariable) and: [aMessageNode receiver name = 'self']) ifTrue: [
		aMessageNode selector = #subclassResponsibility ifTrue: [
			accepted := true.
			^ self]].
	super acceptMessageNode: aMessageNode .
! !

TODeclarationVisitor subclass: #TODGetterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODGetterVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:35'!
acceptReturnNode: aReturnNode 
	|lit|
	lit := aReturnNode value.
	((lit isVariable) and: [lit isLocallyBound not]) ifTrue: [accepted := true]! !

TODeclarationVisitor subclass: #TODTypePredicateVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypePredicateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:42'!
acceptReturnNode: aReturnNode 
	|lit|
	lit := aReturnNode value.
	((lit isLiteralNode) and: [lit value isKindOf: Boolean]) ifTrue: [accepted := true]
	! !

TODeclarationVisitor subclass: #TODTypeStateVisitor
	instanceVariableNames: 'hasReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:35'!
acceptReturnNode: aReturnNode 
	hasReturn := true.
	super acceptReturnNode: aReturnNode .! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:24'!
acceptVariableNode: aVariableNode
	|name |
	name := aVariableNode name.
	(#(self super) includes: name) ifTrue: [ accepted := true. ^self.].
	
	"dependent on FEFI"
	aVariableNode  isLocallyBound ifFalse: [ accepted := true]
	
	 
	 ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 00:34'!
accepted 
	^ accepted & hasReturn ! !

!TODTypeStateVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:32'!
initialize 
	super initialize .
	hasReturn := false.! !

!TODeclarationVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:46'!
accept: def
	^ self new mthDef: def  ; 
		visitNode: (RBParser permissiveParseMethod: def source) ; 
		accepted
	 ! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
accepted 
	^ accepted ! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:52'!
initialize 
	super initialize .
	accepted := false.! !

!TODeclarationVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:47'!
mthDef: cdef
	mthDef := cdef ! !

TODeclarationVisitor subclass: #TOFilterVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

TOFilterVisitor subclass: #TOFDoesNotUnderstandVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFDoesNotUnderstandVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:49'!
acceptMethodNode: aMethodNode 
	accepted :='doesNotUnderstand*' match: aMethodNode selector! !

TOFilterVisitor subclass: #TOFNonBoolVisitor
	instanceVariableNames: 'hasReturn'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:01'!
acceptReturnNode: aReturnNode 
	|node|
	hasReturn := true.
	node := aReturnNode value.
	node isLiteralNode ifTrue: [
		(node value isKindOf: Boolean) ifFalse: [accepted :=true]].
	((node isVariable) and: [#(self super) includes: node name]) ifTrue: [accepted := true]! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:02'!
accepted 
	^ accepted | hasReturn not! !

!TOFNonBoolVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:02'!
initialize 
	super initialize .
	hasReturn := false.! !

TOFilterVisitor subclass: #TOFNonLocalVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Visitor'!

!TOFNonLocalVisitor methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 17:50'!
acceptVariableNode: aVariableNode
	accepted := mthDef clsDef hasInstanceVariable: aVariableNode name metaClass: mthDef classIsMeta  ! !

!TOFilterVisitor class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:38'!
canBeFilter: def
	^ self subclasses anySatisfy: [:filter | filter accept: def]! !

!EcoSystem methodsFor: '*toc-declaration' stamp: 'OzC 12/21/2011 12:59'!
retrieveDeclarations
	|doc|
	doc:= TOProjectDictionary new.
	projects do: [:p| |dot name|
		name := p projectName.
		dot := doc at: name ifAbsentPut: (TOProject new projectName: name).
		p versions last mcVersion loadDeclarationIn: dot.
		dot isEmpty ifTrue: [doc removeKey: name].
		] displayingProgress: 'Reading projects'.
	^doc! !

Object subclass: #AbstractTrackedSelectors
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

Object subclass: #NilFamily
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Tracking-Core'!

!NilFamily class methodsFor: 'as yet unclassified' stamp: 'OzC 1/10/2012 22:09'!
trackSelectors
	^   #(#haltIfNil #ifNil: #ifNil:ifNotNilDo: #ifNil:ifNotNil: #ifNotNilDo: #ifNotNilDo:ifNil: #ifNotNil: #ifNotNil:ifNil: #isEmptyOrNil #isNil #notNil)! !

Object subclass: #TOProject
	instanceVariableNames: 'projectName selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOProject class methodsFor: 'selector-patterns' stamp: 'OzC 1/18/2012 10:01'!
matchSelector: selector
	self selectorPatterns do:[:patt|  |idx|
		idx := patt size + 1.
		(((patt , '#*') match: selector) and: [
			((selector at: idx) isUppercase | ( (selector at: idx) = $: ))]) ifTrue: [^ true]
		].
	^ false
! !

!TOProject class methodsFor: 'selector-patterns' stamp: 'OzC 1/18/2012 09:57'!
selectorPatterns
	^#(is has does should shall can could may maybe might would will "if")! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 22:14'!
addSelector: "(MCMthDef)" mthDef
	|tos|
	tos:=selectors at: mthDef tocName ifAbsent:[ 
		selectors at: mthDef tocName put: (TOSelector newFrom: mthDef). 
		^ self]. "1st occ."
	
	"2nd+ occ. [thing better this]"
	tos validate: mthDef 
	! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 23:01'!
copyMixPredicates
	|neo|
	neo := self class new projectName: self projectName .
	self mixPredicates do: [:tos| neo selectors at: tos mthDef tocName put: tos].
	^ neo! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 23:04'!
hasMixPredicates
	selectors do: [:tos |
		(selectors keys select:[:k | 
			(k endsWith: tos selector) and:[k ~= tos mthDef tocName]]) do:[:key|
				tos class ~= (selectors at: key) class ifTrue:[^true]]].
	^ false! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 19:48'!
initialize 
	selectors := Dictionary new.! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 12:59'!
isEmpty
	^ selectors size == 0! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 19:58'!
matchSelector: selector
	^ self class matchSelector: selector ! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/19/2011 23:04'!
mixPredicates
	|mix|
	mix := Set new.
	selectors do: [:tos |
		(selectors keys select:[:k | 
			(k endsWith: tos selector) and:[k ~= tos mthDef tocName]]) do:[:key|
				tos class ~= (selectors at: key) class ifTrue:[mix add: tos]]].
	^ mix! !

!TOProject methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 14:04'!
printString 
	|name|
	name := projectName,' ',(selectors size asString),'#'.
	(selectors size) > 0 ifTrue:  [
		{#isTypePredicate -> 'type' . #isStatePredicate->'state' . #isAbstractSelector -> 'abstr' . #isExtra -> 'extra'} do: [:pair|
			name := name, ', ',(selectors select: pair key) size asString,(pair value)]].
	^ name! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName
	^ projectName! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
projectName: anObject
	projectName := anObject! !

!TOProject methodsFor: 'accessing' stamp: 'OzC 12/16/2011 19:47'!
selectors
	^ selectors! !

Object subclass: #TOSelector
	instanceVariableNames: 'mthDef validated unvalidated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

TOSelector subclass: #TOAbstractSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOAbstractSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:53'!
shortName 
	^ 'Abstract'! !

!TOAbstractSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:53'!
visitorClass 
	^ TODAbstractSelectorVisitor! !

!TOAbstractSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:52'!
isAbstractSelector 
	^ true! !

TOSelector subclass: #TOExtraSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOExtraSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Extra'! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isExtra
	^true! !

!TOExtraSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:10'!
validate: def
	self class visitorClasses do: [:tot|
		(tot visitorClass accept: def) 
			ifTrue: [self unvalidated add: def. ^self]].
	self validated add: def.! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 12:38'!
newFrom: mthDef
	"order define precendece"
	self visitorClasses do: [:tot|
		(tot visitorClass accept: mthDef) ifTrue: [^ tot new mthDef: mthDef] ].
	^ TOExtraSelector new mthDef: mthDef  ! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ self subclassResponsibility ! !

!TOSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:31'!
visitorClasses
	^
	"order define precendece"
	{TOAbstractSelector . TOGetterSelector . TOStatePredicateSelector . TOTypePredicateSelector} ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:41'!
<= another
	self selector  = another selector ifFalse: [^ self selector <= another selector].
	^ self mthDef tocName <= another mthDef tocName ! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/20/2011 09:36'!
duplicatesLength
	|n|
	n:= validated ifNil: [0] ifNotNil: [validated size]. 
	n:= n + (unvalidated ifNil: [0] ifNotNil: [unvalidated size]). 
	^ n! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/21/2011 13:52'!
isAbstractSelector 
	^ false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isExtra
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 1/18/2012 11:36'!
isGetter
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/21/2011 13:43'!
isStatePredicate
	^false! !

!TOSelector methodsFor: 'testing' stamp: 'OzC 12/16/2011 23:53'!
isTypePredicate
	^false! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/16/2011 20:05'!
mthDef
	^ mthDef! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:07'!
mthDef: def
	mthDef := def! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 10:14'!
pattern
	|selector|
	selector := mthDef selector.
	1 to:  selector size do: [:i| |chr|
		chr:= selector at: i.
		(chr isUppercase | chr = $:) ifTrue: [^ selector first: i]].
	^  'non-pattern'! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 11:30'!
printString 
	^ self class shortName, '[',mthDef tocName,']'! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/19/2011 22:06'!
selector
	^ mthDef selector! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
unvalidated 
	^ unvalidated ifNil: [unvalidated := Set new.]! !

!TOSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 13:03'!
validate: def
	((self class visitorClass accept: def) 
		ifTrue: [self validated] ifFalse:[ self unvalidated]) add: def! !

!TOSelector methodsFor: 'accessing' stamp: 'OzC 12/17/2011 00:04'!
validated 
	^ validated ifNil: [validated := Set new.]! !

TOSelector subclass: #TOStatePredicateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

TOStatePredicateSelector subclass: #TOGetterSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOGetterSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 10:39'!
shortName 
	^ 'Getter'! !

!TOGetterSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 10:40'!
visitorClass 
	^ TODGetterVisitor! !

!TOGetterSelector methodsFor: 'as yet unclassified' stamp: 'OzC 1/18/2012 11:36'!
isGetter 
	^ true! !

!TOStatePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:33'!
shortName 
	^ 'State'! !

!TOStatePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypeStateVisitor! !

!TOStatePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:43'!
isStatePredicate  
	^ true! !

TOSelector subclass: #TOTypePredicateSelector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOC-Declaration-Core'!

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/17/2011 10:32'!
shortName 
	^ 'Type'! !

!TOTypePredicateSelector class methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 21:57'!
visitorClass 
	^ TODTypePredicateVisitor! !

!TOTypePredicateSelector methodsFor: 'as yet unclassified' stamp: 'OzC 12/16/2011 23:54'!
isTypePredicate 
	^true! !

!MCClassDefinition methodsFor: '*toc-declaration' stamp: 'OzC 1/18/2012 17:56'!
hasInstanceVariable: varName metaClass: isMeta
	^ (isMeta 
		ifTrue: [(self selectVariables: #isClassInstanceVariable) 
				union: (self selectVariables: #isClassVariable)] 
		ifFalse: [self selectVariables: #isInstanceVariable]) includes: varName! !
